# Goal of this script is to retrieve erased EPROCESS entries from PspCidTable
# Written my Matthieu Suiche (June 2009)
# http://msuiche.net

function Get-DD()
{
    # Initialize array.

    $outArray = @()

    $i = 0   # Initialize index counter.

    $stringReader = [System.IO.StringReader] $global:g_commandOutput

    # Scan the symbols line by line.
    while(($line = $stringReader.ReadLine()) -ne $null)
    {
        if($line -match "((?<address1>(^\w+))\s+(?<address2>(\w+))\s+(?<address3>(\w+))\s+(?<address4>(\w+))\s+(?<address5>(\w+)))")
        {
            #$outArray[$i++] = $matches["address1"]
            #$o = $outArray.Add($matches["address2"])
            #$o = $outArray.Add($matches["address3"])
            #$o = $outArray.Add($matches["address4"])
            #$o = $outArray.Add($matches["address5"])
            
            $outArray = $outArray + $matches["address2"]
            $outArray = $outArray + $matches["address3"]
            $outArray = $outArray + $matches["address4"]
            $outArray = $outArray + $matches["address5"]
        }  
    } 
    return $outArray
}

function Get-DDAddress()
{
    $stringReader = [System.IO.StringReader] $global:g_commandOutput
    
    # Scan the symbols line by line.
    while(($line = $stringReader.ReadLine()) -ne $null)
    {
		if($line -match "((?<address1>(^\w+))\s+(?<address2>(\w+)))")
		{
			$Addr = $matches["address1"]
		}
    } 
    return $Addr 
}

function  Get-FileNameFromEProcess()
{
    $stringReader = [System.IO.StringReader] $global:g_commandOutput

    $FileName = $null

    # Scan the symbols line by line.
    while(($line = $stringReader.ReadLine()) -ne $null)
    {
		if($line -match "`"(.+.)`"")
		{
			$FileName = $matches[0]
		}
    } 
    return $FileName 
}

Import-Module Windbg
Open-Crashdump "C:\Users\Homer\Desktop\Shakacon\Demos\Dmp\cmd_hidden_FUto.dmp"
#Load-PowerDbgSymbols "SRV*c:\symbols*http://msdl.microsoft.com/download/symbols"

Send-PowerDbgCommand "dt nt!_HANDLE_TABLE poi(nt!PspCidTable)"
Parse-PowerDbgDT -useFieldNames
$HandleTable = @{}
$HandleTable = Convert-PowerDbgCSVToHashTable
#$HandleTable 

# Compare KTHREAD.SystemTable with nt!KeServiceDescriptorTable
# Then save ETHREAD.ThreadsProcess

$LayerLevel = $HandleTable["TableCode"] -band 3
$HandleCount = $HandleTable["HandleCount"]

#echo "TableCode $HandleTable["TableCode"]"
#echo $HandleTable["TableCode"]
$TableEntry = $HandleTable["TableCode"] -band 0xfffffff8
$TableEntry = ("{0:x}" -f $TableEntry)
#echo $TableEntry

$RetrievedProcessList = @()
$RetrievedProcessCount = 0

$ProcessList = @()
$ProcessCount = 0

if ($LayerLevel -eq 0)
{
	#echo "Layer 0 not implemented yet."
	#echo "Layer 0."
	Send-PowerDbgCommand("dd nt!KeServiceDescriptorTable L1")
	$KeServiceDescriptorTable = Get-DDAddress
	
	#echo "KeServiceDescriptorTable: $KeServiceDescriptorTable"
	#$KeServiceDescriptorTable = "0x$KeServiceDescriptorTable"
	#echo $KeServiceDescriptorTable
	$KeServiceDescriptorTable = ([Convert]::ToInt32($KeServiceDescriptorTable, 16))
	
	Send-PowerDbgCommand("dd nt!KeServiceDescriptorTableShadow L1")
	$KeServiceDescriptorTableShadow = Get-DDAddress
	$KeServiceDescriptorTableShadow = ([Convert]::ToInt32($KeServiceDescriptorTableShadow, 16))

	#echo $TableEntry
	#echo "dd 0x$TableEntry L400"
	Send-PowerDbgCommand("dd nt!PspCidTable-nt!PspCidTable+$TableEntry L400")
	$b = Get-DD
	#echo "APRES"
	#echo $b
	#echo "end"
	# (PAGE_SIZE / sizeof(HANDLE_TABLE_ENTRY)) = 0x200
	for ($y = 0; $y -lt 0x200; $y++)
	{
		#echo "To Read"
		#echo "Reading $b[$y*2]"
		# _HANDLE_TABLE_ENTRY 
		$ThreadOrProcessOffset = ([Convert]::ToInt32($b[$y*2], 16))
		if ($ThreadOrProcessOffset -eq 0)
		{
			continue
		}
		
		$ThreadOrProcessOffset = (($ThreadOrProcessOffset -bor 0x80000000) -band 0xfffffff8)
		$ThreadOrProcessOffset = ("{0:x}" -f $ThreadOrProcessOffset)
		
		
		# Check if this is a process or a thread structure
		#echo "ThreadOrProcessOffset"
		#echo $ThreadOrProcessOffset
		Send-PowerDbgCommand "dt nt!_KTHREAD 0x$ThreadOrProcessOffset"
		Parse-PowerDbgDT -useFieldNames
		$ThreadOrProcess = @{}
		$ThreadOrProcess = Convert-PowerDbgCSVToHashTable

		#echo "====> SystemTable"
		#$ServiceTable = ("{0:x}" -f $ThreadOrProcess["ServiceTable"])
		
		$ServiceTable = $ThreadOrProcess["ServiceTable"]
		$ServiceTable = $ServiceTable -replace " ", ""
		$ServiceTable = ([Convert]::ToInt32($ServiceTable, 16))
		#$KeServiceDescriptorTable
		
		
		# Damn this is ugly 
		if (($ServiceTable -eq $KeServiceDescriptorTable) -or ($ServiceTable -eq $KeServiceDescriptorTableShadow))
		{
			#echo "THREAD FOUND!"
			# THREAD
			Send-PowerDbgCommand "dt nt!_ETHREAD $ThreadOrProcessOffset"
			Parse-PowerDbgDT -useFieldNames
			$Thread = @{}
			$Thread = Convert-PowerDbgCSVToHashTable

			# Add Process
			$CheckIndex = 0;

			if($Thread["ThreadsProcess"] -match "0x\S+")
			{
				$ThreadsProcess = $matches[0]
				#echo $ThreadsProcess
			}
			while ($CheckIndex -lt $RetrievedProcessList.Count)
			{
				if ($RetrievedProcessList[$CheckIndex] -match $ThreadsProcess)
				{
					break
				}

				$CheckIndex++
			}

			if ($CheckIndex -ge $RetrievedProcessList.Count)
			{
				#$o = $RetrievedProcessList.Add($Thread["ThreadsProcess"])
				$RetrievedProcessList = $RetrievedProcessList + $ThreadsProcess
				$RetrievedProcessCount++
				#echo "Retrieved Process List $ThreadsProcess"
			}
		}
		else
		{
			#echo "PROCESS"
			#echo $ThreadOrProcessOffset
			# Add PROCESS
			$CheckIndex = 0;

			#Send-PowerDbgCommand("dt nt!_EPROCESS ImageFileName 0x$ThreadOrProcessOffset")
			#$FileName =  Get-FileNameFromEProcess
			#echo $FileName

			while ($CheckIndex -lt $ProcessList.Count)
			{
				if ($ProcessList[$CheckIndex] -match $ThreadOrProcessOffset)
				{
					break
				}

				$CheckIndex++
			}

			if ($CheckIndex -ge $ProcessList.Count)
			{
				#$o = $ProcessList.Add($ThreadOrProcessOffset)
				$ProcessList = $ProcessList + "0x$ThreadOrProcessOffset"
				#echo "Process list $ThreadOrProcessOffset"
				$ProcessCount++
			}
		}
	}
}
elseIf($LayerLevel -eq 1)
{
	#echo "Layer 1."
	Send-PowerDbgCommand("dd nt!KeServiceDescriptorTable L1")
	$KeServiceDescriptorTable = Get-DDAddress
	
	#echo "KeServiceDescriptorTable: "
	#$KeServiceDescriptorTable = "0x$KeServiceDescriptorTable"
	#echo $KeServiceDescriptorTable
	$KeServiceDescriptorTable = ([Convert]::ToInt32($KeServiceDescriptorTable, 16))
	
	Send-PowerDbgCommand("dd nt!KeServiceDescriptorTableShadow L1")
	$KeServiceDescriptorTableShadow = Get-DDAddress
	$KeServiceDescriptorTableShadow = ([Convert]::ToInt32($KeServiceDescriptorTableShadow, 16))
	
	Send-PowerDbgCommand("dd nt!PspCidTable-nt!PspCidTable+0x$TableEntry L400")
	$a = Get-DD
	#echo "Print address at:"
	#$TableEntry

	$PreviousObject = 0
	
	# (PAGE_SIZE / sizeof(ULONG)) = 0x400
	for ($x = 0; $x -lt 0x400; $x++)
	{		

		if ($a[$x] -eq "00000000")
		{
			break
		}

		$Address = ("{0:x}" -f $a[$x])
		#echo "Table xx"
		#$Address
		Send-PowerDbgCommand("dd nt!PspCidTable-nt!PspCidTable+0x$Address L400")
		$b = Get-DD

		# (PAGE_SIZE / sizeof(HANDLE_TABLE_ENTRY)) = 0x200
		for ($y = 0; $y -lt 0x200; $y++)
		{
			#echo "To Read"
			#echo $b[$y*2]
			# _HANDLE_TABLE_ENTRY 
			$ThreadOrProcessOffset = ([Convert]::ToInt32($b[$y*2], 16))
			if ($ThreadOrProcessOffset -eq 0)
			{
				continue
			}
			
			$ThreadOrProcessOffset = (($ThreadOrProcessOffset -bor 0x80000000) -band 0xfffffff8)
			$ThreadOrProcessOffset = ("{0:x}" -f $ThreadOrProcessOffset)
			
			
			# Check if this is a process or a thread structure
			#echo "ThreadOrProcessOffset"
			#echo $ThreadOrProcessOffset
			Send-PowerDbgCommand "dt nt!_KTHREAD 0x$ThreadOrProcessOffset"
			Parse-PowerDbgDT -useFieldNames
			$ThreadOrProcess = @{}
			$ThreadOrProcess = Convert-PowerDbgCSVToHashTable

			#echo "====> SystemTable"
			#$ServiceTable = ("{0:x}" -f $ThreadOrProcess["ServiceTable"])
			
			$ServiceTable = $ThreadOrProcess["ServiceTable"]
			$ServiceTable = $ServiceTable -replace " ", ""
			$ServiceTable = ([Convert]::ToInt32($ServiceTable, 16))
			#$KeServiceDescriptorTable
			
			
			# Damn this is ugly 
			if (($ServiceTable -eq $KeServiceDescriptorTable) -or ($ServiceTable -eq $KeServiceDescriptorTableShadow))
			{
				#echo "THREAD FOUND!"
				# THREAD
				Send-PowerDbgCommand "dt nt!_ETHREAD $ThreadOrProcessOffset"
				Parse-PowerDbgDT -useFieldNames
				$Thread = @{}
				$Thread = Convert-PowerDbgCSVToHashTable

				# Add Process
				$CheckIndex = 0;

				if($Thread["ThreadsProcess"] -match "0x\S+")
				{
					$ThreadsProcess = $matches[0]
				}
				while ($CheckIndex -lt $RetrievedProcessList.Count)
				{
					if ($RetrievedProcessList[$CheckIndex] -match $ThreadsProcess)
					{
						break
					}

					$CheckIndex++
				}

				if ($CheckIndex -ge $RetrievedProcessList.Count)
				{
					#$o = $RetrievedProcessList.Add($Thread["ThreadsProcess"])
					$RetrievedProcessList = $RetrievedProcessList + $ThreadsProcess
					$RetrievedProcessCount++
				}
			}
			else
			{
				#echo "PROCESS"
				#echo $ThreadOrProcessOffset
				# Add PROCESS
				$CheckIndex = 0;

				#Send-PowerDbgCommand("dt nt!_EPROCESS ImageFileName 0x$ThreadOrProcessOffset")
				#$FileName =  Get-FileNameFromEProcess
				#echo $FileName

				while ($CheckIndex -lt $ProcessList.Count)
				{
					if ($ProcessList[$CheckIndex] -match $ThreadOrProcessOffset)
					{
						break
					}

					$CheckIndex++
				}

				if ($CheckIndex -ge $ProcessList.Count)
				{
					#$o = $ProcessList.Add($ThreadOrProcessOffset)
					$ProcessList = $ProcessList + $ThreadOrProcessOffset
					$ProcessCount++
				}
			}
		}
	}
}
elseIf($LayerLevel -eq 2)
{
	#echo "Layer 2 not implemented yet."
}

#echo "Number of Process found:"
#echo $ProcessList.Count

#echo "Number of retrieved process"
#echo $RetrievedProcessList.Count
#$RetrievedProcessList

$HiddenCount = 0
$NotHiddenCount = 0
$NotHiddenProcess = @()
$HiddenProcess = @()

$SavedNotHiddenCount = 0

	foreach ($ProcessFromThreads in $RetrievedProcessList)
	{
		$SavedNotHiddenCount = $NotHiddenCount

		foreach ($ProcessFromProcess in $ProcessList)
		{
			#echo "Compare $ProcessFromProcess with $ProcessFromThreads"

			if ($ProcessFromProcess -match $ProcessFromThreads)
			{
				$NotHiddenProcess = $NotHiddenProcess + $ProcessFromThreads
				$NotHiddenCount++
				#echo "$ProcessFromThreads is not hidden"
			}
		}
	
		if ($NotHiddenCount -eq $SavedNotHiddenCount)
		{
			#$o = $HiddenProcess.Add($ProcessFromThreads)
			$HiddenProcess = $HiddenProcess + $ProcessFromThreads
			$HiddenCount++
			#echo "$ProcessFromThreads is hidden"
		}
	}

$DT = new-object Data.datatable

$DR = $DT.NewRow()
$EPROCESS = new-object Data.DataColumn
$ProcessName = new-object Data.DataColumn
$Status = new-object Data.DataColumn
$EPROCESS.ColumnName = "EPROCESS"
$ProcessName.ColumnName = "Process Name"
$Status.ColumnName = "Status"

$DT.Columns.Add($EPROCESS)
$DT.Columns.Add($ProcessName)
$DT.Columns.Add($Status)

foreach ($Process in $NotHiddenProcess)
{
	$DR = $DT.NewRow()
	$DR.Item("EPROCESS") = $Process
	Send-PowerDbgCommand("dt nt!_EPROCESS ImageFileName $Process")
	$FileName =  Get-FileNameFromEProcess
	$DR.Item("Process Name") = $FileName
	$DR.Item("Status") = "Not Hidden"
	$DT.Rows.Add($DR)
}

foreach ($Process in $HiddenProcess)
{
	$DR = $DT.NewRow()
	$DR.Item("EPROCESS") = $Process
	Send-PowerDbgCommand("dt nt!_EPROCESS ImageFileName $Process")
	$FileName =  Get-FileNameFromEProcess	
	$DR.Item("Process Name") = $FileName
	$DR.Item("Status") = "Hidden"
	$DT.Rows.Add($DR)
}

$DT

Close-Crashdump 